/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.TCoreElementHierarchy.TCoreElementHierarchyPath;
import de.ship.db.tables.TImportMapping.TImportMappingPath;
import de.ship.db.tables.records.TImportMappingRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TImportMapping extends TableImpl<TImportMappingRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_import_mapping</code>
     */
    public static final TImportMapping T_IMPORT_MAPPING = new TImportMapping();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TImportMappingRecord> getRecordType() {
        return TImportMappingRecord.class;
    }

    /**
     * The column <code>common_dd.t_import_mapping.lastchange</code>.
     */
    public final TableField<TImportMappingRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_import_mapping.pk</code>. the used id, act
     * as primary key
     */
    public final TableField<TImportMappingRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "the used id, act as primary key");

    /**
     * The column <code>common_dd.t_import_mapping.dn</code>. foreign key to
     * T_CORE_ELEMENT_HIERARCHY.dn
     */
    public final TableField<TImportMappingRecord, String> DN = createField(DSL.name("dn"), SQLDataType.CLOB.nullable(false), this, "foreign key to T_CORE_ELEMENT_HIERARCHY.dn");

    /**
     * The column <code>common_dd.t_import_mapping.dn_mapping</code>. mapping
     * domain name in import source
     */
    public final TableField<TImportMappingRecord, String> DN_MAPPING = createField(DSL.name("dn_mapping"), SQLDataType.CLOB.nullable(false), this, "mapping domain name in import source");

    /**
     * The column <code>common_dd.t_import_mapping.fk_import_mapping</code>. the
     * id from parent
     */
    public final TableField<TImportMappingRecord, Integer> FK_IMPORT_MAPPING = createField(DSL.name("fk_import_mapping"), SQLDataType.INTEGER, this, "the id from parent");

    private TImportMapping(Name alias, Table<TImportMappingRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TImportMapping(Name alias, Table<TImportMappingRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_import_mapping</code> table reference
     */
    public TImportMapping(String alias) {
        this(DSL.name(alias), T_IMPORT_MAPPING);
    }

    /**
     * Create an aliased <code>common_dd.t_import_mapping</code> table reference
     */
    public TImportMapping(Name alias) {
        this(alias, T_IMPORT_MAPPING);
    }

    /**
     * Create a <code>common_dd.t_import_mapping</code> table reference
     */
    public TImportMapping() {
        this(DSL.name("t_import_mapping"), null);
    }

    public <O extends Record> TImportMapping(Table<O> path, ForeignKey<O, TImportMappingRecord> childPath, InverseForeignKey<O, TImportMappingRecord> parentPath) {
        super(path, childPath, parentPath, T_IMPORT_MAPPING);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TImportMappingPath extends TImportMapping implements Path<TImportMappingRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TImportMappingPath(Table<O> path, ForeignKey<O, TImportMappingRecord> childPath, InverseForeignKey<O, TImportMappingRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TImportMappingPath(Name alias, Table<TImportMappingRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TImportMappingPath as(String alias) {
            return new TImportMappingPath(DSL.name(alias), this);
        }

        @Override
        public TImportMappingPath as(Name alias) {
            return new TImportMappingPath(alias, this);
        }

        @Override
        public TImportMappingPath as(Table<?> alias) {
            return new TImportMappingPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TImportMappingRecord, Integer> getIdentity() {
        return (Identity<TImportMappingRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TImportMappingRecord> getPrimaryKey() {
        return Keys.PK_IMPORT_MAPPING;
    }

    @Override
    public List<UniqueKey<TImportMappingRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.UK_IMPORTMAPPING_DN, Keys.UK_IMPORT_MAPPING);
    }

    @Override
    public List<ForeignKey<TImportMappingRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_IMPORT_MAPPING__FK_IMPORT_MAPPING_DN, Keys.T_IMPORT_MAPPING__FK_IMPORT_MAPPING_ID);
    }

    private transient TCoreElementHierarchyPath _tCoreElementHierarchy;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_element_hierarchy</code> table.
     */
    public TCoreElementHierarchyPath tCoreElementHierarchy() {
        if (_tCoreElementHierarchy == null)
            _tCoreElementHierarchy = new TCoreElementHierarchyPath(this, Keys.T_IMPORT_MAPPING__FK_IMPORT_MAPPING_DN, null);

        return _tCoreElementHierarchy;
    }

    private transient TImportMappingPath _tImportMapping;

    /**
     * Get the implicit join path to the <code>common_dd.t_import_mapping</code>
     * table.
     */
    public TImportMappingPath tImportMapping() {
        if (_tImportMapping == null)
            _tImportMapping = new TImportMappingPath(this, Keys.T_IMPORT_MAPPING__FK_IMPORT_MAPPING_ID, null);

        return _tImportMapping;
    }

    @Override
    public TImportMapping as(String alias) {
        return new TImportMapping(DSL.name(alias), this);
    }

    @Override
    public TImportMapping as(Name alias) {
        return new TImportMapping(alias, this);
    }

    @Override
    public TImportMapping as(Table<?> alias) {
        return new TImportMapping(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TImportMapping rename(String name) {
        return new TImportMapping(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TImportMapping rename(Name name) {
        return new TImportMapping(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TImportMapping rename(Table<?> name) {
        return new TImportMapping(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TImportMapping where(Condition condition) {
        return new TImportMapping(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TImportMapping where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TImportMapping where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TImportMapping where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TImportMapping where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TImportMapping where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TImportMapping where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TImportMapping where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TImportMapping whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TImportMapping whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
